//Open GL - Generate Gray Codes... 
//
//
//
//gcc -o Hello_World Hello_world.c -lX11 -lMesaGL -lMesaGLU -lMesatk -lm
//
#include <stdio.h> // for printf call
#include <stdlib.h> // for exit() call.
#include <GL/glut.h>


int bit = 0;
int speedFlag = 0;  // go fast by default.
int repeatCount = 1; 


int timeOfLastRedraw = 0;


// The "repeatInverse" flag is used to indicate if we should be repeating
// the inverse of each bit immidately after sending it.
//  The repeatInverseCount = 1 means that we should be sending the inverted bit.
int repeatInverse = 0;
int repeatInverseCount = 0;

//FPS variables...
int fpsFlag = 1; // no FPS by default.
int frame=0,time,timebase=0; char fpsString[40];// FPS counter...
float fps; char *c;
int font=(int)GLUT_BITMAP_8_BY_13;

enum codeTypes { BINARY,GRAY_HV, GRAY_POS, GRAY_DIAG_POS,SEC_ECC,RANDOM, SPEED_SLOW, SPEED_MEDIUM,SPEED_FAST,REPEAT_NONE,REPEAT_INVERSE,
QUIT};
enum codeTypes codeType = SEC_ECC;

void init(void); // function header for Init.
int getBitSEC_ECC(unsigned short databits, int bitPosition);




void processMenuEvents(int option) {

  switch (option) {
	  case BINARY:
		  codeType = BINARY;
		  break;
	  case GRAY_HV:
		  codeType = GRAY_HV;
		  break;
	  case GRAY_POS:
		  codeType = GRAY_POS;
		  break;
	  case GRAY_DIAG_POS:
		  codeType = GRAY_DIAG_POS;
		  break;
	  case SEC_ECC:
		  codeType = SEC_ECC;
		  break;
	  case RANDOM:
		  codeType = RANDOM;
		  break;
	  case SPEED_SLOW:
		  speedFlag=2;
		  break;
	  case SPEED_MEDIUM:
		  speedFlag=1;
		  break;
	  case SPEED_FAST:
		  speedFlag=0;
		  break;
	  case REPEAT_NONE:
		  repeatInverse = 0;
		  break;
	  case REPEAT_INVERSE:
		  repeatInverse = 1;
		  repeatInverseCount = 0;
		  break;
	  case QUIT:
		  exit(0);
	  default:
		  break;
  } // end switch.

}

void createGLUTMenus(){
	int menu;
	int submenuCodeType;
	int submenuSpeed;
	int submenuRepeat;

	//create the meu and
	//tell glut that "processMenuEvents" will
	//handle the events
	submenuCodeType = glutCreateMenu(processMenuEvents);
	glutAddMenuEntry("Alternating Binary",BINARY);
	glutAddMenuEntry("Gray - H then V", GRAY_HV);
	glutAddMenuEntry("Gray - H and V", GRAY_POS);
	glutAddMenuEntry("Gray - Diagonal",GRAY_DIAG_POS);
	glutAddMenuEntry("SEC-ECC",SEC_ECC);
	glutAddMenuEntry("Random",RANDOM);

        submenuSpeed = glutCreateMenu(processMenuEvents);
	glutAddMenuEntry("SPEED - Slow",SPEED_SLOW);
	glutAddMenuEntry("SPEED - Medium",SPEED_MEDIUM);
	glutAddMenuEntry("SPEED - Fast",SPEED_FAST);

	submenuRepeat = glutCreateMenu(processMenuEvents);
	glutAddMenuEntry("Repeat - none",REPEAT_NONE);
	glutAddMenuEntry("Repeat - Inverse",REPEAT_INVERSE);

	menu = glutCreateMenu(processMenuEvents);
	glutAddSubMenu("Code Type",submenuCodeType);
	glutAddSubMenu("Render Speed",submenuSpeed);
	glutAddSubMenu("Repeat",submenuRepeat);

	glutAddMenuEntry("Quit",QUIT);
	glutAttachMenu(GLUT_RIGHT_BUTTON);
	
}


static GLfloat spin  = 0.0;

int getBitSEC_ECC(unsigned short databits, int bitPosition)
{
	        // Load the databits into an array, one bit per element.
		  unsigned char d[16];
		  unsigned char c[21];
		  unsigned short int temp;

		   unsigned short int mask = 0x0001;
		    int i,j;
		     for(i = 0; i < 16; i++)
		      {
	               temp = 0x00;	
	               temp = databits & mask; // Grab one bit.
	               mask <<= 1; // advance to the next bit in the mask.
		    // Shift the data point back to the first bit position.
		             for(j = i; j>0; j--)
		                {
		                 temp >>= 1;
		                 }
			     d[i] = temp ;
		     }


	 // Move the data bits into the appropriate codeword positions
     c[2] = d[0];
     c[4] = d[1]; c[5]=d[2]; c[6] = d[3];
     c[8] = d[4]; c[9]=d[5]; c[10]=d[6]; c[11]=d[7]; c[12]=d[8]; c[13] = d[9];
     c[14] = d[10];
     c[16] = d[11]; c[17]=d[12]; c[18]=d[13]; c[19]=d[14]; c[20]=d[15];

     // Calculate the check bits.
     
     c[0] = c[2] ^ c[4] ^ c[6] ^ c[8] ^ c[10] ^ c[12] ^ c[14] ^ c[16] ^ c[18] ^ c[20];
     c[1] = c[2] ^ c[5] ^ c[6] ^ c[9] ^ c[10] ^ c[13] ^ c[14] ^ c[17] ^ c[18];
     c[3] = c[4] ^ c[5] ^ c[6] ^ c[11]^ c[12] ^ c[13] ^ c[14] ^ c[19] ^ c[20];
     c[7] = c[8] ^ c[9] ^ c[10] ^c[11] ^ c[12] ^ c[13] ^ c[14];
     c[15] = c[16] ^ c[17] ^ c[18] ^ c[19] ^ c[20];

     // return the appropriate bit...
     for(i = 0; i < 21; i++)
     {
	     if (i == bitPosition)
		     return(c[i]);
     }
     return(0); //should never be hit...
}

 

int getBit(int x, int y, int frame)
{

	 int internalBit = 0;
	 int positionNum = 0;
	 int n,v,dig,set,k;
	 unsigned short int temp;

	switch(codeType)
	{
         case BINARY:
		 // Do 2-1-2-1-2-1
		 if ( (frame+1) %3 > 0)
			 return(1);
		 else
			 return(0);


		 //return((frame+1) % 2); // Alternating zero's and ones...
		 break;
	 case SEC_ECC:
		 // This one uses 21 bits to transfer 16 bits of data.
		 positionNum = x * 32 + y;
		 // We can use the upper six bits for whatever we want...
		 temp = (unsigned short int)positionNum;
		 temp |=0xA800;
		return (getBitSEC_ECC(temp,frame));
		 break;
	  // Do a gray code based upon the position, using a
	  // scanline type algorithm for applying positions to
	  // integers (e.g. proceed along rows and columns
	  case GRAY_POS:

	   //Calculate unique digit for this position...
	   positionNum = 32 * x + y;
	   //printf("positionNum = %d\n",positionNum);

         // Hack! Generate all possible Gray codes up to this point and
	 // stop and return the correct bit for us...
         n = 10; // 1024 squares...	32x32

	//Generate the Gray code for this position...
	 v = 1 << n;

	 set = positionNum ^(positionNum>>1);

	 for(dig = 1 << (n-1); dig; dig >>=1)
	 {
           if (internalBit == frame) 
		   return( set&dig ? 1 : 0);
           else
	   {
		   internalBit++;
	   }
	 }
	 break; // will never be reached, but anyways....


	 //*****************************
	 //Do all of the vertical changes first (5 bits)
	 //and then do all of the horizontal changes second (5 bits)
	  case GRAY_HV:
	  n = 5; // five bits each...
	  if (frame < 5) // Horizontal stuff first...
		positionNum = x;
	  else
	  {
		positionNum = y;
		frame -= 5; // reduce the frame count by 5 for the 2nd time.
	  }

	//Generate the Gray code for this position...
	 v = 1 << n;

	 set = positionNum ^(positionNum>>1);

	 for(dig = 1 << (n-1); dig; dig >>=1)
	 {
           if (internalBit == frame) 
		   return( set&dig ? 1 : 0);
           else
	   {
		   internalBit++;
	   }
	 }
	 break; // will never be reached, but anyways....

	 //*******************************************
	 // GRAY_DIAG_POS
	 //  Using the bijective function between the rational
	 //  numbers and the natural numbers, we assign the "position"
	 //  diagonally.

	  case GRAY_DIAG_POS:
	   //Calculate unique digit for this position...
	   k = x + y;
	   positionNum = x + k * ((k+2)/2);
	   //printf("positionNum = %d\n",positionNum);

         // Hack! Generate all possible Gray codes up to this point and
	 // stop and return the correct bit for us...
         n = 10; // 1024 squares...	32x32

	//Generate the Gray code for this position...
	 v = 1 << n;

	 set = positionNum ^(positionNum>>1);

	 for(dig = 1 << (n-1); dig; dig >>=1)
	 {
           if (internalBit == frame) 
		   return( set&dig ? 1 : 0);
           else
	   {
		   internalBit++;
	   }
	 }
	 break;

	  case RANDOM:
	 n = rand();
	 if (n > RAND_MAX / 2)
	 {
		 return(1);
	 }
	 else
	 {
		 return(0);
	 }
	 break;


	default:
	 break;
	}// end switch

 // If we ever get an all black screen, it's because this
 // return was executed!
  return(0);
}

void display(void)
{
 int i,j;

 //printf("Bit: %d",bit);
 //printf("  Sample Pixel (20,20) : %d\n", getBit(20,20,bit));

  // clear all pixels.
  glClear(GL_COLOR_BUFFER_BIT);

  // Draw 32x32 rectangles...
  for( i=0; i < 32; i++)
     for( j = 0; j < 32; j++)
     {
//	      int temp = getBit(3,4,bit);
	     int temp = getBit(i,j,bit);
              //printf("Position: %d Bit: %d - %d\n",32*i+j,bit,temp);
	      //is it time to invert the bit?
	    if (repeatInverse == 1 && repeatInverseCount > 0) 
	    {
              if (temp == 1)
		      temp =0;
	      else
		      temp = 1; 

	//	    temp = 0;
	    }


       if (temp == 1)
	       glColor3f(1.0, 1.0, 1.0);
       else
	       glColor3f(0.0, 0.0, 0.0);

        if (i == 8 && j == 8)
		printf("bit:%d - %d\n",bit,temp);

       glRectf( (i-16)*2 , 2*(j-16),((i-16)*2)+2,((j-16)*2)+2);


     }

  //glFlush();
  //glFinish();
  glutSwapBuffers();
}

void generate_code(void)
{

	//FPS counter code:
	//
	frame++;
	time=glutGet(GLUT_ELAPSED_TIME);
			
	if (time - timebase > 1000) {
		fps = frame*1000.0/(time-timebase);
		printf("FPS:%4.2f\n", fps);
		timebase = time;		
		frame = 0;
	}

// State to determine if we should repeat each bit by projecting it's
// inverse.
if (repeatInverse == 0)
{
	bit++;
}
if (repeatInverse == 1)
{
 
	if (repeatInverseCount ==0)
		repeatInverseCount = 1;
	else
	{
		repeatInverseCount = 0;
		bit++;
	}  
}


 

 if (repeatCount == 0)
 {
     glutIdleFunc(0);
     bit=0;
 }

 if (speedFlag ==1)
 {
  // Dam it! Didn't find a portable sleep/Sleep call between unix/windows...
   int clockClicks = glutGet(GLUT_ELAPSED_TIME);
   while(glutGet(GLUT_ELAPSED_TIME) < clockClicks + 100);
 }
 if (speedFlag == 2)
{
// Dam it! Didn't find a portable sleep/Sleep call between unix/windows...
    int clockClicks = glutGet(GLUT_ELAPSED_TIME);
       while(glutGet(GLUT_ELAPSED_TIME) < clockClicks + 500);
}

 //determine how many bits to do and when to reset for each
 //type of code...
 
 switch(codeType) {
	 case GRAY_HV:
	 case GRAY_POS:
	 case GRAY_DIAG_POS:
	// Stop  and reset if we have done all 10 bits...
	if (bit > 9 )
 	{
		 bit = 0;
		 repeatCount--;


 	}
 	break;
	// We do 21 bits for the SEC_ECC (encoding 16 bits of data) 
	 case SEC_ECC: 
	   if (bit > 20)
	   {
		   bit = 0;
		   repeatCount--;
	   }
	   break;
	 case RANDOM:
	   if (bit > 20)
	   {
		bit = 0;
		repeatCount--;
	   }
	   break;
	  case BINARY:
	   if (bit > 21)
	   {
		bit = 0;
		repeatCount--;
	   }
	   break;

	 default:
 	   bit = 0;
	   repeatCount--;
	   break;
 } // end switch.


glutPostRedisplay();

}

void reshape(int w, int h)
{
	glViewport(0,0,(GLsizei) w, (GLsizei) h);
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	glOrtho(-32.0,32.0,-32.0,32.0, -1.0, 1.0);
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
}

//Keyboard handler
void keyboard(int key, int x, int y) {
	switch(key){
	case GLUT_KEY_F1:
		glutGameModeString("640x480");
		// This test always fails.. but the
		// code below seems to work for me :>
		//if (glutGameModeGet(GLUT_GAME_MODE_POSSIBLE)) {
			glutEnterGameMode();
			init();
	//	}else
	//		printf("GLUT- Full screen mode not possible");

		break;
	case GLUT_KEY_F2:
		glutFullScreen();
		break;
	case GLUT_KEY_F3:
		glutReshapeWindow(250,250);
		glutPositionWindow(100,100);
		break;
	case GLUT_KEY_F6:
		glutIdleFunc(0);
		repeatCount = 0;
		bit = 0;
		glutLeaveGameMode();
		break;
	} // end switch.

}

void mouse(int button, int state, int x, int y)
{
  switch(button) {
	  // Left button, run once...
	  case GLUT_LEFT_BUTTON:
		  if (state == GLUT_DOWN) {
			  bit = 0; // start at 0 bit.
			  repeatCount = 2; // repeat twice.
			  glutIdleFunc(generate_code);
		  }
		  break;
	  case GLUT_MIDDLE_BUTTON:
		  if (state == GLUT_DOWN) {
			  bit = 0; repeatCount = 15;
			  glutIdleFunc(generate_code);
		  }
		  break;
	  default:
		  break;
  }
}

void init(void)
{
  glClearColor(0.0,0.0,0.0,0.0);
  glutDisplayFunc(display);
  glutReshapeFunc(reshape);
  glutMouseFunc(mouse);
  glutSpecialFunc(keyboard);

}

int main(int argc, char** argv)
{
  glutInit(&argc,argv);
  glutInitDisplayMode(GLUT_RGBA|GLUT_DOUBLE);
  glutInitWindowSize(250,250);
  glutInitWindowPosition(100,100);
  glutCreateWindow(argv[0]);
  init();
  createGLUTMenus();
  glutMainLoop();
  return 0;
}

